- [HTTP request](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.request_body)
- [Response body](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.response_body)
  - [JSON representation](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.BillingRatesListResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#body.aspect)
- [BillingRate](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRate)
  - [JSON representation](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRate.SCHEMA_REPRESENTATION)
- [Type](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#Type)
- [UnitOfMeasure](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#UnitOfMeasure)
- [BillingRateTieredRate](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRateTieredRate)
  - [JSON representation](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRateTieredRate.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#try-it)

Retrieves a list of billing rates. This method supports [paging](https://developers.google.com/doubleclick-advertisers/trafficking_tasks#list).

### HTTP request

`GET https://dfareporting.googleapis.com/dfareporting/v5/userprofiles/{profileId}/billingProfiles/{billingProfileId}/billingRates`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `profileId` | `string (https://developers.google.com/discovery/v1/type-format format)` User profile ID associated with this request. |
| `billingProfileId` | `string (https://developers.google.com/discovery/v1/type-format format)` Billing profile ID of this billing rate. |

### Request body

The request body must be empty.

### Response body

Billing Rate billingRates.list Response

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "nextPageToken": string, "billingRates": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRate`) } ] } ``` |

| Fields ||
|---|---|
| `kind` | `string` Identifies what kind of resource this is. Value: the fixed string `"dfareporting#billingRatesListResponse"`. |
| `nextPageToken` | `string` Pagination token to be used for the next list operation. |
| `billingRates[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRate`)`` Billing rates collection. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/dfatrafficking`

## BillingRate

| JSON representation |
|---|
| ``` { "id": string, "name": string, "type": enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#Type`), "startDate": string, "endDate": string, "currencyCode": string, "unitOfMeasure": enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#UnitOfMeasure`), "rateInMicros": string, "tieredRates": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRateTieredRate`) } ] } ``` |

| Fields ||
|---|---|
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` ID of this billing rate. |
| `name` | `string` Name of this billing rate. This must be less than 256 characters long. |
| `type` | ``enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#Type`)`` Type of this billing rate. |
| `startDate` | `string` Start date of this billing rate. |
| `endDate` | `string` End date of this billing rate. |
| `currencyCode` | `string` Billing currency code in ISO 4217 format. |
| `unitOfMeasure` | ``enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#UnitOfMeasure`)`` Unit of measure for this billing rate. |
| `rateInMicros` | `string (https://developers.google.com/discovery/v1/type-format format)` Flat rate in micros of this billing rate. This cannot co-exist with tiered rate. |
| `tieredRates[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/billingRates/list#BillingRateTieredRate`)`` Tiered rate of this billing rate. This cannot co-exist with flat rate. |

## Type

| Enums ||
|---|---|
| `AD_SERVING` |   |
| `CLICKS` |   |
| `MINIMUM_SERVICE` |   |
| `PATH_TO_CONVERSION` |   |
| `RICH_MEDIA_INPAGE` |   |
| `RICH_MEDIA_EXPANDING` |   |
| `RICH_MEDIA_FLOATING` |   |
| `RICH_MEDIA_VIDEO` |   |
| `RICH_MEDIA_TEASER` |   |
| `RICH_MEDIA_VPAID` |   |
| `INSTREAM_VIDEO` |   |
| `PIXEL` |   |
| `TRACKING` |   |
| `TRAFFICKING_FEATURE` |   |
| `CUSTOM_REPORTS` |   |
| `EXPOSURE_TO_CONVERSION` |   |
| `DATA_TRANSFER` |   |
| `DATA_TRANSFER_SETUP` |   |
| `STARTUP` |   |
| `STATEMENT_OF_WORK` |   |
| `PROVIDED_LIST` |   |
| `PROVIDED_LIST_SETUP` |   |
| `ENHANCED_FORMATS` |   |
| `TRACKING_AD_IMPRESSIONS` |   |
| `TRACKING_AD_CLICKS` |   |
| `NIELSEN_DIGITAL_AD_RATINGS_FEE` |   |
| `INSTREAM_VIDEO_REDIRECT` |   |
| `INSTREAM_VIDEO_VPAID` |   |
| `DISPLAY_AD_SERVING` |   |
| `VIDEO_AD_SERVING` |   |
| `AUDIO_AD_SERVING` |   |
| `ADVANCED_DISPLAY_AD_SERVING` |   |

## UnitOfMeasure

| Enums ||
|---|---|
| `CPM` |   |
| `CPC` |   |
| `EA` |   |
| `P2C` |   |

## BillingRateTieredRate

| JSON representation |
|---|
| ``` { "lowValue": string, "highValue": string, "rateInMicros": string } ``` |

| Fields ||
|---|---|
| `lowValue` | `string (https://developers.google.com/discovery/v1/type-format format)` The minimum for this tier range. |
| `highValue` | `string (https://developers.google.com/discovery/v1/type-format format)` The maximum for this tier range. |
| `rateInMicros` | `string (https://developers.google.com/discovery/v1/type-format format)` Rate in micros for this tier. |